\section{Basic concepts}

The fundamental storage unit is the \emph{byte}, which is a sequence of 8 bits.
The storage (or memory) available to a program consists of one or more sequences of contiguous bytes. 
Every byte has a unique address.

The following paragraphs describe the entities of the language. An \emph{entity} is an abstract element of a program that is described by, created by, or
referred to in a program.

A \emph{value} is element of a set.
For example the value zero is an element in the set of integers and the set of real numbers.
Similarly, the value true is an element in the set boolean values; the other value is false.
A value can also be an address.
When this document refers to specific values, they are spelled in English using the normal font.

A \emph{type} describes objects, references, functions, and expressions.
The meaning of the type is determined by the the entity it describes.

An \emph{object} is region of storage, comprised of a fixed length sequence
of bytes.
Note that every object has an address.
Every object has a type, which determines the size of the object and how its stored bits can be interpreted as a value (i.e., an object stores a value).
Objects are created by definitions or when a temporary object is created.

A \emph{reference} can be thought of as an alias (name) for an object or alternatively as an address for the object.
Every reference has a type, which determines the set of objects to which the reference can bind.
It is unspecified whether a reference requires storage.
References are created by definitions.

A \emph{variable} is the definition of an object or reference.

A \emph{function} maps a sequence of input values, called \emph{arguments},
to an output value, called its \emph{return value}.
Every function has a type, which determines the arguments that it can accept as inputs the type of value that it returns as an output.
Functions are created by definitions.

